/* $Id: phonesw.c,v 3.2 1991/03/25 21:12:05 piggy Rel $
 * Return an index based on the day, hour and minute we are working
 *
 *   Copyright (C) 1991  Lele Gaifax (piggy@idea.sublink.org)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * SYNOPSIS:
 * int  GetPhonePrice(int day, int hour, int minute)
 *      Return an index in PHONE_PRICING_TB_NAMES, calculated from day, hour,
 *      minute.
 *
 * NOTE: Probably you'll need to customize this function for your country.
 *       Please, include your code, if any, between ifdefs, as I did, and
 *       send me the diffs, so I can keep this file up to date ;-)
 */

#include "hdbstat.h"

#ifdef ITALY

char *PhoneCategoryNames[] =
{
  "Peak Time   ",		/* 8:30am to 1pm */
  "Normal Time ",		/* 8am to 8:30am, 1pm to 6:30pm */
  "Evening Time",		/* 6:30pm to 10pm */
  "Night Time  "		/* 10pm to 8 am */
};

/*
 * This function get the Day of the Week, the Hour, and the Minute, and
 * return an integer indicating in which timebelt we are.
 */

int
GetPhonePrice (day, hour, min)
     int day, hour, min;

{
  int retvalue;
  
  switch (day)
    {
    case 0:			/* Sunday */
      retvalue = ((hour < 8 || hour >= 22) ? 3 : 2);
      break;

    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
      if (hour < 8 || hour >= 22)
	retvalue = 3;
      else if (hour > 18 || (hour == 18 && min >= 30))
	retvalue = 2;
      else if ((hour > 8 && hour < 13) || (hour == 8 && min >= 30))
	retvalue = 0;
      else retvalue = 1;
      break;
      
    case 6:			/* Saturday */
      if (hour < 8 || hour >= 22)
	retvalue = 3;
      else if (hour >= 8 && hour < 13)
	retvalue = 1;
      else retvalue = 2;
      break;
    }
  return retvalue;
}

#endif /* ifdef ITALY */
